# line 1 "ing.sc"	
# include "/opt/Ingres/IngresII/ingres/files/eqdef.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "tx/request.h"


#include "iixa.h"	// TODO delete and remove int hack

# include "/opt/Ingres/IngresII/ingres/files/eqsqlca.h"
    IISQLCA *IIsqlca();
# define sqlca (*(IIsqlca()))

# line 11 "ing.sc"	/* host code */
static int verbose = 1;
/*
EXEC SQL DECLARE XEMP TABLE
	(EMPNO     integer NOT NULL PRIMARY KEY,
	ENAME     varchar(32));
*/
void dbOpenError() {
	userlogc_warn("dbOpenError\n");
}

static int isInTxn() {
# line 22 "ing.sc"	
  
  int trxflag;
# line 24 "ing.sc"	
  
# line 25 "ing.sc"	/* inquire_sql */
  {
    IILQisInqSqlio((short *)0,1,30,sizeof(trxflag),&trxflag,73);
  }
# line 26 "ing.sc"	/* host code */
	return trxflag != 0;
}

static int getError(char *errbuf, size_t sz) {
# line 30 "ing.sc"	
  
  char errmsg[101];
# line 32 "ing.sc"	
  
# line 33 "ing.sc"	/* inquire_sql */
  {
    IILQisInqSqlio((short *)0,1,32,100,errmsg,63);
  }

# line 35 "ing.sc"	/* host code */
	/*
	 * - defines for sqlcodes are defined in generr.h
	 * - the meaning of the codes in documented in SQLRef guide
	 */
	if (sqlca.sqlcode < 0) {
   		userlogc_debug("ing_access: %s", errmsg);

		if (errbuf)
			userlogc_snprintf(errbuf, sz, "%s", errmsg);
	} else if (sqlca.sqlcode > 0) {
   		userlogc_debug("ing_access: %d %s", sqlca.sqlcode, errmsg);
	}

	return sqlca.sqlcode;
}

static void
doSelect(int argempnum, char *argename, int *rcnt) {
	int validCsr = 0;
# line 54 "ing.sc"	
  
  int empno = argempnum;
  char ename[21];
# line 57 "ing.sc"	
  


# line 64 "ing.sc"	/* host code */
	userlogc_debug("ing_access: doSelect opening cursor (inTx=%d) ...", isInTxn());
# line 65 "ing.sc"	/* open */
  {
    IIsqInit(&sqlca);
    IIcsOpen((char *)"empcsr",1288864517,681799903);
    IIwritio(0,(short *)0,1,32,0,(char *)
"select empno, ename from xemp where empno>=");
    IIputdomio((short *)0,1,30,sizeof(empno),&empno);
    IIcsQuery((char *)"empcsr",1288864517,681799903);
  }

# line 67 "ing.sc"	/* host code */
	if (sqlca.sqlcode != 0) {
		userlogc_debug("ing_access: doSelect cursor open error %d", getError(NULL, 0));
		return;
	}

	userlogc_debug("ing_access: doSelect selecting ...");
	while (1) {
# line 74 "ing.sc"	/* fetch */
  {
    IIsqInit(&sqlca);
    if (IIcsRetScroll((char *)"empcsr",1288864517,681799903,-1,-1) != 0) {
      IIcsGetio((short *)0,1,30,sizeof(empno),&empno);
      IIcsGetio((short *)0,1,32,20,ename);
      IIcsERetrieve();
    } /* IIcsRetrieve */
  }

# line 76 "ing.sc"	/* host code */
		if (sqlca.sqlcode == 0) {
			userlogc_debug("ing_access: doSelect selected empno %d", empno);
			validCsr = 1;
			*rcnt += 1;
			if (verbose)
				userlogc_debug("%d, %s\n", empno, ename);
		} else {
			userlogc_debug("ing_access: doSelect selected %d records", *rcnt);
			break;
		}
	}

	userlogc_debug("ing_access: doSelect close_cursor isValid=%d", validCsr);
	if (validCsr)
# line 90 "ing.sc"	/* close */
  {
    IIsqInit(&sqlca);
    IIcsClose((char *)"empcsr",1288864517,681799903);
  }
# line 91 "ing.sc"	/* host code */
	userlogc_debug("ing_access: doSelect cursor closed");
}

static void
doInsert(int argempnum, char *argename) {
# line 96 "ing.sc"	
  
  int empnum = argempnum;
  char *ename = argename;
# line 99 "ing.sc"	
  

	userlogc_debug("ing_access: insert into XEMP (empno, ename) values (%d, %s) (inTx=%d) (sqlcode=%d)",
		empnum, ename, isInTxn(), sqlca.sqlcode);
# line 103 "ing.sc"	/* insert */
  {
    IIsqInit(&sqlca);
    IIwritio(0,(short *)0,1,32,0,(char *)
"insert into XEMP(empno, ename)values(");
    IIputdomio((short *)0,1,30,sizeof(empnum),&empnum);
    IIwritio(0,(short *)0,1,32,0,(char *)", ");
    IIputdomio((short *)0,1,32,0,ename);
    IIwritio(0,(short *)0,1,32,0,(char *)")");
    IIsyncup((char *)0,0);
  }
# line 104 "ing.sc"	/* host code */
	userlogc_debug("ing_access: finished insert (inTx=%d) (sqlcode=%d)", isInTxn(), sqlca.sqlcode);
	getError(NULL,0);
}

static void
doUpdate(int argempnum, char *argename) {
# line 110 "ing.sc"	
  
  int empno = argempnum;
  char *ename = argename;
# line 113 "ing.sc"	
  

# line 115 "ing.sc"	/* update */
  {
    IIsqInit(&sqlca);
    IIwritio(0,(short *)0,1,32,0,(char *)"update XEMP set ename=");
    IIputdomio((short *)0,1,32,0,ename);
    IIwritio(0,(short *)0,1,32,0,(char *)"where empno=(");
    IIputdomio((short *)0,1,30,sizeof(empno),&empno);
    IIwritio(0,(short *)0,1,32,0,(char *)")");
    IIsyncup((char *)0,0);
  }
# line 116 "ing.sc"	/* host code */
}

static void
doDelete(int argempnum, char *argename) {
int rcnt;
# line 121 "ing.sc"	
  
  int empno = argempnum;
# line 123 "ing.sc"	
  

	userlogc_debug("ing_access: delete from XEMP where empno >= %d (inTx=%d)", empno, isInTxn());
# line 126 "ing.sc"	/* delete */
  {
    IIsqInit(&sqlca);
    IIwritio(0,(short *)0,1,32,0,(char *)"delete from XEMP where empno\
>=(");
    IIputdomio((short *)0,1,30,sizeof(empno),&empno);
    IIwritio(0,(short *)0,1,32,0,(char *)")");
    IIsyncup((char *)0,0);
  }
# line 127 "ing.sc"	/* host code */
	userlogc_debug("ing_access: delete finished (inTx=%d)", isInTxn());
doSelect(empno, "", &rcnt);
userlogc_debug("ing_access: doSelect from %d after doDelete rcnt=%d (%d) (inTx=%d)",
		empno, rcnt, sqlca.sqlcode, isInTxn());
}

static void
doInvalid(int argempnum, char *argename) {
# line 135 "ing.sc"	
  
  int empno = argempnum;
# line 137 "ing.sc"	
  

	userlogc_debug("delete from xXEMP where empno >= %d\n", empno);
# line 140 "ing.sc"	/* delete */
  {
    IIsqInit(&sqlca);
    IIwritio(0,(short *)0,1,32,0,(char *)"delete from xXEMP where empn\
o>=(");
    IIputdomio((short *)0,1,30,sizeof(empno),&empno);
    IIwritio(0,(short *)0,1,32,0,(char *)")");
    IIsyncup((char *)0,0);
  }
# line 141 "ing.sc"	/* host code */
}

long ing_xaflags() {
    return 0L;
}

# line 147 "ing.sc"	
#ifdef HACK
static int hack = 0;
static void xaopen() {
	if (hack) {
		int ret = iixa_switch.xa_open_entry((char *) "INGRES BTDB2 as BTDB2", 403, TMNOFLAGS);
		if (ret != XA_OK)
			userlogc("ing_access: xaopen INGRES BTDB2 failure: %d\n", ret);
		hack = 0;
	}
}
# line 157 "ing.sc"	
#endif

int ing_access(test_req_t *req, test_req_t *resp)
{
# line 161 "ing.sc"	
  
  char *dbname;
  char *dbname2 = "BTDB2";
# line 164 "ing.sc"	
  

    int status = -1;
    int rcnt = 0;   // no of matching records
	int empno = (*req->data ? atoi(req->data) : 8000);

# line 170 "ing.sc"	
#ifdef HACK
xaopen();
# line 172 "ing.sc"	
#endif
	(resp->data)[0] = 0;
	dbname = req->db;

	userlogc_debug("ing_access: op=%c conn=%s (inTx=%d)", req->op, dbname, isInTxn());

	userlogc_debug("ing_access: set conn  (inTx=%d)", isInTxn());
# line 179 "ing.sc"	/* set connection */
  {
    IILQssSetSqlio(13,(short *)0,1,32,0,dbname);
  }
# line 180 "ing.sc"	/* host code */
	getError(NULL, 0);
	userlogc_debug("ing_access: conn set  (inTx=%d)", isInTxn());

	if (sqlca.sqlcode < 0) {
		userlogc_debug("ing_access: set conn error %d", getError(NULL, 0));
		resp->status = sqlca.sqlcode;
		return resp->status;
	}

	if (req->op == '0') {	/* insert */
		doInsert(empno, "Jim");
	} else if (req->op == '1') {	/* select */
		doSelect(empno, "", &rcnt);
		userlogc_snprintf(resp->data, sizeof (resp->data), "%d", rcnt);
		userlogc_debug("%d records (%s)\n", rcnt, resp->data);
	} else if (req->op == '2') {	/* update */
		doUpdate(empno, "Bob");
	} else if (req->op == '3') {	/* delete */
		doDelete(empno, "");
	} else {	/* ? */
		userlogc_debug("invalid request op: %d\n", req->op);
		/*doInvalid(empno, "");*/
	}

	status = getError(resp->data, sizeof (resp->data));
	userlogc_debug("ing_access: result=%d", status);

	userlogc_debug("ing_access: clear conn (inTx=%d)", isInTxn());
# line 208 "ing.sc"	
#ifdef HACK
# line 209 "ing.sc"	/* set connection */
  {
    IILQssSetSqlio(13,(short *)0,1,32,0,dbname2);
  }
# line 210 "ing.sc"	/* host code */
#else
# line 211 "ing.sc"	/* set connection */
  {
    IILQssSetSqlio(11,(short *)0,1,30,sizeof(-97),(void *)IILQint(-97));
  }
# line 212 "ing.sc"	/* host code */
#endif
	getError(NULL, 0);
	userlogc_debug("ing_access: clear conn result: %d (inTx=%d)", sqlca.sqlcode, isInTxn());

	resp->status = (status < 0 ? status : 0);
	return resp->status;
}
